/* FindFile Dll ********************************************************
 *
 * Version:			1.5.0.0
 * FileName:		findfile.dll
 * Date Created:	3/25/2002
 *
 * Author:			Soul_Eater
 * Comments:
 *		This is used to find/list files
 *
 *******************************************************************/

#pragma check_stack(off)
#pragma comment(linker,"/OPT:NOWIN98")
#include <windows.h>

//Global Vars.
HWND mwnd;

BOOL IsListBox(HWND hWnd)
{
      TCHAR szClassName[64];
	  int nRet = GetClassName(hWnd, szClassName, 64);
      if(nRet == 0) return FALSE;
      szClassName[nRet] = 0;
	 if (strcmp(szClassName,"ListBox") == 0)
           return TRUE;
      return FALSE;
}
BOOL IsComboBox(HWND hWnd)
{
      TCHAR szClassName[64];
      int nRet = GetClassName(hWnd, szClassName, 64);
      if(nRet == 0) return FALSE;
      szClassName[nRet] = 0;
	  if (strcmp(szClassName,"ComboBox") == 0)
           return TRUE;
      return FALSE;
}
char *StripSpace(char *text)
{
	char *Text = text;
	int slot = 0,num = strlen(text);
	if (text[0] == ' ')
	{
		for (int i = 1;i <= num;i++)
		{
			Text[slot] = text[i];
			slot++;
		}
	}
	return Text;
}
void Gettok(char *string,char *outstring,char sepchar,int whichTok,int maxlen) {
	int count = 0;
	int outputcount = 0;
	int tokencount = 0;
	while (string[count]) {
		if ((string[count] == sepchar) && (count != 0)) {
			if (tokencount == whichTok)
				break;
			tokencount++;
		}
		else if (tokencount == whichTok) { 
			if (outputcount == maxlen)
				break;
			outstring[outputcount] = string[count];
			outputcount++;
		}
		count++;
	}
	outstring[outputcount] = '\0';
	if (outstring[0] == 32)
		wsprintf(outstring,"%s",StripSpace(outstring));
	if (outstring[strlen(outstring)-1] == 32)
		outstring[strlen(outstring)-1] = '\0';
}
int __stdcall LbList(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, 
					   BOOL nopause)
{
    char dialog[150], id[150], dir[300];
	Gettok(data,dialog,'>',0,150);
	Gettok(data,id,'>',1,150);
	Gettok(data,dir,'>',2,300);
  
	HWND dname = (HWND)atoi(dialog);

  if (!IsWindow(dname)) { 
	  lstrcpy(data,"FF_ERR Dialog does not exist."); 
	  return 3; 
  }
 int did;
 did = atoi(id);
 did = did + 6000;
 HWND dialogid = GetDlgItem(dname,did);
 if (!IsWindow(dialogid)) { 
	 lstrcpy(data,"FF_ERR Dialog ID does not exist."); 
	 return 3; 
 }
 if (!IsListBox(dialogid)) {
	 lstrcpy(data,"FF_ERR Dialog ID is not a listbox.");
	 return 3;
 }

   DlgDirList(dname,dir,did,0,DDL_ARCHIVE | DDL_HIDDEN
| DDL_READONLY | DDL_READWRITE | DDL_SYSTEM);

lstrcpy(data,"FF_OK");
		return 3;
}

int __stdcall ComboList(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, 
					   BOOL nopause)
{
    char dialog[150], id[150], dir[300];
	Gettok(data,dialog,'>',0,150);
	Gettok(data,id,'>',1,150);
	Gettok(data,dir,'>',2,300);
  
	HWND dname = (HWND)atoi(dialog);

  if (!IsWindow(dname)) { 
	  lstrcpy(data,"FF_ERR Dialog does not exist."); 
	  return 3; 
  }
 int did;
 did = atoi(id);
 did = did + 6000;
 HWND dialogid = GetDlgItem(dname,did);
 if (!IsWindow(dialogid)) { 
	 lstrcpy(data,"FF_ERR Dialog ID does not exist."); 
	 return 3; 
 }
 if (!IsComboBox(dialogid)) {
	 lstrcpy(data,"FF_ERR Dialog ID is not a combobox.");
	 return 3;
 }

   DlgDirListComboBox(dname,dir,did,0,DDL_ARCHIVE | DDL_HIDDEN
| DDL_READONLY | DDL_READWRITE | DDL_SYSTEM);

lstrcpy(data,"FF_OK");
		return 3;
}

int __stdcall TxtList(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, 
					   BOOL nopause)
{
   char dir[300], output[900], end[300], rdir[300], other[900], options[300];
   WIN32_FIND_DATA FindFileData;
  HANDLE hFind = NULL;
  HANDLE hFile;
  DWORD bytesWritten;
  Gettok(data,dir,'>',0,300);
  Gettok(data,output,'>',1,900);
  Gettok(dir,rdir,'*',0,300);
  Gettok(data,options,'>',2,300);
 // rdir[strlen(rdir)-1] = '\0';
  hFile = CreateFile(output,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

  //l = long filename
  //d = directory
  //s = short filename
  //b = size in bytes

  if (stricmp(options,"+l") == 0) { 

  hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++;
   WriteFile(hFile,FindFileData.cFileName,strlen(FindFileData.cFileName),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
 } while (FindNextFile(hFind, &FindFileData) != 0); 
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  if (stricmp(options,"+ld") == 0) { 

  hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++;
   wsprintf(other,"%s%s",rdir,FindFileData.cFileName);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
 } while (FindNextFile(hFind, &FindFileData) != 0); 
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  if (stricmp(options,"+lb") ==0) {
	   hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++; 
   wsprintf(other,"%s %d",FindFileData.cFileName,FindFileData.nFileSizeLow);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
    } while (FindNextFile(hFind, &FindFileData) != 0);
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }

   if (stricmp(options,"+ld") == 0) { 

  hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++;
   wsprintf(other,"%s%s",rdir,FindFileData.cFileName);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
 } while (FindNextFile(hFind, &FindFileData) != 0); 
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  if (stricmp(options,"+lbd") ==0) {
	   hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++; 
   wsprintf(other,"%s%s %d",rdir,FindFileData.cFileName,FindFileData.nFileSizeLow);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
    } while (FindNextFile(hFind, &FindFileData) != 0);
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  if (stricmp(options,"+s") == 0) { 

  hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++;
   WriteFile(hFile,FindFileData.cAlternateFileName,strlen(FindFileData.cAlternateFileName),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
 } while (FindNextFile(hFind, &FindFileData) != 0); 
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  if (stricmp(options,"+sd") == 0) { 

  hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++;
   wsprintf(other,"%s%s",rdir,FindFileData.cAlternateFileName);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
 } while (FindNextFile(hFind, &FindFileData) != 0); 
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  if (stricmp(options,"+sb") ==0) {
	   hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++; 
   wsprintf(other,"%s %d",FindFileData.cAlternateFileName,FindFileData.nFileSizeLow);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
    } while (FindNextFile(hFind, &FindFileData) != 0);
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }

   if (stricmp(options,"+sd") == 0) { 

  hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++;
   wsprintf(other,"%s%s",rdir,FindFileData.cAlternateFileName);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
 } while (FindNextFile(hFind, &FindFileData) != 0); 
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  if (stricmp(options,"+sbd") ==0) {
	   hFind = FindFirstFile(dir, &FindFileData);
  
  if (hFind == INVALID_HANDLE_VALUE) 
 {  
    CloseHandle(hFile); 
    lstrcpy(data,"No files found."); 
    return 3;
 } 
 int fCount = 0;
 do {
   fCount++; 
   wsprintf(other,"%s%s %d",rdir,FindFileData.cAlternateFileName,FindFileData.nFileSizeLow);
   WriteFile(hFile,other,strlen(other),&bytesWritten,NULL);
   WriteFile(hFile,"\r\n",2,&bytesWritten,NULL);  
    } while (FindNextFile(hFind, &FindFileData) != 0);
  FindClose(hFind);
  CloseHandle(hFile);
  wsprintf(end,"%d",fCount);
  lstrcat(end," ");
  lstrcat(end,"files. FF_OK");
  lstrcpy(data,end);
	return 3;
  }
  else {
	  lstrcpy(data,"Please select an option using +sldb");
	  return 3;
  }
}

int MsgBox(char *data)
{
 int xa = MessageBox (mwnd , data , "FindFile DLL" , MB_OK | MB_ICONINFORMATION );
 return 0;
}

int WINAPI DllInfo(HWND,HWND,char *data,char*,BOOL,BOOL)
{
   MsgBox("File DLL 1.5 by Soul_Eater, AIM: SoulEata , Email- souleata@xrs.net");
   return 0;
}

